﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BlockPuzzleSolution
{
    public partial class NewBlock : Form
    {
        Button[,] buttons = new Button[5, 5];
        internal Block Block;
        public NewBlock(Color c)
        {
            InitializeComponent();
            for (int i = 0; i < 5; i++) 
                for (int j = 0; j < 5; j++)
                {
                    buttons[i, j] = new Button();
                    buttons[i, j].BackColor = Color.White;
                    buttons[i, j].Anchor = AnchorStyles.Bottom | AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
                    buttons[i, j].Margin = new Padding(0);
                    buttons[i, j].Click += new EventHandler(button_Click);
                    table1.Controls.Add(buttons[i, j], i, 4 - j);
                }
            colorPicker.Color = c;
        }

        public NewBlock() : this(Color.Red)
        {
        }


        private void btnCreate_Click(object sender, EventArgs e)
        {
            Block = new Block();
            int top=5, bottom=-1, left=-1, right=5;
            bool limit = false;
            while (!limit && top > 0)
            {
                top--;
                for (int i = 0; i < 5; i++)
                {
                    if (buttons[i, top].BackColor.Equals(colorPicker.Color))
                    {
                        limit = true; break;
                    }
                }
            }

            limit = false;
            while (!limit && bottom < 4)
            {
                bottom++;
                for (int i = 0; i < 5; i++)
                {
                    if (buttons[i, bottom].BackColor.Equals(colorPicker.Color))
                    {
                        limit = true; break;
                    }
                }
            }

            limit = false;
            while (!limit && right >0)
            {
                right--;
                for (int i = 0; i < 5; i++)
                {
                    if (buttons[right, i].BackColor.Equals(colorPicker.Color))
                    {
                        limit = true; break;
                    }
                }
            }

            limit = false;
            while (!limit && left < 4)
            {
                left++;
                for (int i = 0; i < 5; i++)
                {
                    if (buttons[left, i].BackColor.Equals(colorPicker.Color))
                    {
                        limit = true; break;
                    }
                }
            }

            if (left > right || top < bottom)
            {
                MessageBox.Show("No input detected!");
                return;
            }

            Block.BlockSize = new Size(right - left + 1, top - bottom + 1);
            Block.MyColor = colorPicker.Color;
            for(int i=left;i<=right;i++)
                for (int j = bottom; j <= top; j++)
                {
                    if (buttons[i, j].BackColor.Equals(colorPicker.Color))
                    {
                        Block.setMatrix(i - left, j - bottom, 1);
                    }
                }
            this.DialogResult = DialogResult.OK;
            Close();
        }

        private void button_Click(object sender, EventArgs e)
        {
            Button b = (Button)sender;
            if (b.BackColor.Equals(colorPicker.Color)) b.BackColor = Color.White;
            else b.BackColor = colorPicker.Color;
        }

        private void colorPicker_ColorChanged(object sender, EventArgs e)
        {
            for (int i = 0; i < 5; i++)
                for (int j = 0; j < 5; j++)
                {
                    if (!buttons[i, j].BackColor.Equals(Color.White)) buttons[i, j].BackColor = colorPicker.Color;
                }
        }
    }
}
