﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BlockPuzzleSolution
{
    public partial class ShowPuzzle : Form
    {
        internal Puzzle Puzzle;
        int step;
        public ShowPuzzle()
        {
            InitializeComponent();
            
        }

        internal ShowPuzzle(Puzzle p)
        {
            InitializeComponent();
            step = 0;
            Puzzle = p;

            Image image = Puzzle.GetImage(0);
            picPuzzle.Width = Math.Max(image.Width, btnBack.Width+btnNext.Width+5);
            picPuzzle.Height = image.Height;

            btnBack.Location = new Point(picPuzzle.Width / 2 - btnBack.Width - 2, picPuzzle.Location.Y + picPuzzle.Height + 10);
            btnNext.Location = new Point(btnBack.Location.X + btnBack.Width + 4, btnBack.Location.Y);

            this.Width = picPuzzle.Location.X * 2 + picPuzzle.Width + 10;
            this.Height = btnBack.Location.Y + btnBack.Height + 50;

            printPuzzle(0);
        }

        private void printPuzzle(int c)
        {
            Image image = Puzzle.GetImage(c);
            picPuzzle.Image = image;
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            if (step > 0) step--;
            printPuzzle(step);
        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            if (step < Puzzle.Blocks.Count) step++;
            else MessageBox.Show("End of solution.");
            printPuzzle(step);
        }
    }
}
